autowatch = 1;

outlets = 10;

post("'wjl.rainstorm.js' is reloaded");

start();

function start()
{
    post("start rainstorm");
    post();
    outlet(0, "clear");
    for (var i = 0; i < 8; i++)
    {
        outlet(0, "right", "set", i, 4);
    }
    outlet(0, "top", "set", 0, 4);
    outlet(0, "top", "set", 1, 2);
}

var matrix_button_x;
var matrix_button_y;
var last_column_y;
var last_col = new Array(8);
var right_col = new Array(8);
var prev_col = new Array(8);
function tick()
{
    //post("function tick");
    //post();

    for (last_column_y = 0; last_column_y < 8; last_column_y++)
        outlet(0, "right", "get", last_column_y, "col_status");

    for (last_column_y = 0; last_column_y < 8; last_column_y++)
        outlet(0, "matrix", "get", 7, last_column_y, "col");

    //post("function tick shuffle");
    //post();
    for (matrix_button_x = 6; matrix_button_x >= 0; matrix_button_x--)
        for (matrix_button_y = 0; matrix_button_y < 8; matrix_button_y++)
            outlet(0, "matrix", "get", matrix_button_x, matrix_button_y, "shift");

    for (matrix_button_y = 0; matrix_button_y < 8; matrix_button_y++)
        outlet(0, "matrix", "set", 0, matrix_button_y, last_col[matrix_button_y]);
    //post("function tick shuffle done");
    //post();
}

function col_status(color)
{
    right_col[last_column_y] = color;
}

function col(color)
{
    prev_col[last_column_y] = color;
    if (color != 0)
    {
        outlet(last_column_y + 1, "bang")
        if (right_col[last_column_y] == 7)
        {
            last_col[last_column_y] = 0;
        }
        else
        {
            last_col[last_column_y] = color;
        }
    }
    else 
    {   
        last_col[last_column_y] = 0;
    }
}

function shift(color)
{
    if (prev_col[matrix_button_y] != color)
        outlet(0, "matrix", "set", matrix_button_x + 1, matrix_button_y, color);
    prev_col[matrix_button_y] = color
    //post(0, "matrix", "set", matrix_button_x + 1, matrix_button_y, color);
    //post();
}

var pressed_matrix_button_x;
var pressed_matrix_button_y;
function matrix(action, in_1, in_2)
{
    //post("matrix");
    //post();
    if (action == "color")
    {
        //post("matrix color", in_1, in_2);
        //post();
        if (in_2 == "toggle_matrix")
            toggle_matrix(in_1);
        else if (in_2 == "col")
            col(in_1);
        else if (in_2 == "shift")
            shift(in_1);
        //else if (in_2 == "ripple")
        //    ripple(in_1);
    }
    else if (action == 1)
    {
        //post("matrix button ", in_1, in_2, "is pressed");
        pressed_matrix_button_x = in_1;
        pressed_matrix_button_y = in_2;
        outlet(0, "matrix", "get", in_1, in_2, "toggle_matrix");
    }
    else if (action == 0)
    {
    }
}

function toggle_matrix(color)
{
    //post("toggle_matrix");
    //post();
    if (color == 0)
        outlet(0, "matrix", "set", pressed_matrix_button_x, pressed_matrix_button_y, 6);
    else
        outlet(0, "matrix", "set", pressed_matrix_button_x, pressed_matrix_button_y, 0);
}

var pressed_right_button;
function right(action, in_1, fun)
{
    //post("right");
    //post();
    if (action == "color")
    {
        //post("right color", in_1, fun);
        //post();
        if (fun == "toggle_right")
            toggle_right(in_1);
        if (fun == "col_status")
            col_status(in_1);
    }
    else if (action == 1)
    {
        //post("right button ", in_1, "is pressed");
        //post();
        pressed_right_button = in_1;
        outlet(0, "right", "get", in_1, "toggle_right");
    }
    else if (action == 0)
    {
    }
}

function toggle_right(color)
{
    //post("toggle_right");
    //post();
    if (color == 4)
        outlet(0, "right", "set", pressed_right_button, 7);
    else
        outlet(0, "right", "set", pressed_right_button, 4);
}

function top(action, in_1, fun)
{
    post("right");
    post();
    if (action == "color")
    {
        if (fun == "run")
        {
            if (in_1 == 4)
            {
                outlet(0, "top", "set", 0, 7);
                outlet(9, 1)
            }
            else
            {
                outlet(0, "top", "set", 0, 4);
                outlet(9, 0)
            }
            
        }
    }
    else if (action == 0)
    {
        if (in_1 == 0)
        {
            outlet(0, "top", "get", 0, "run");
        }
        else if (in_1 == 1)
        {
            start();
        } 
    }
    else if (action == 0)
    {
    }
}
